"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.calcAmountOut = exports.swap = void 0;
require("dotenv/config");
const swap = (_a) => __awaiter(void 0, [_a], void 0, function* ({ raydiumSwap, tokenA, tokenB, amountIn, direction, maxRetries, slippage, priceImpact, fee, feePercent, feeRecipient, }) {
    const poolInfo = raydiumSwap.findPoolInfoForTokens(tokenA, tokenB);
    if (!poolInfo) {
        throw new Error("Pool info not found");
    }
    const toToken = direction === "AtoB" ? tokenB : tokenA;
    const transactionInfo = yield raydiumSwap.getSwapTransaction(toToken, amountIn, poolInfo, slippage, priceImpact, fee, feePercent, feeRecipient);
    const txid = yield raydiumSwap.sendLegacyTransaction(transactionInfo.transaction, maxRetries);
    return txid;
});
exports.swap = swap;
const calcAmountOut = (_b) => __awaiter(void 0, [_b], void 0, function* ({ raydiumSwap, tokenA, tokenB, amountIn, direction, }) {
    const poolInfo = raydiumSwap.findPoolInfoForTokens(tokenA, tokenB);
    if (!poolInfo) {
        throw new Error("Pool info not found");
    }
    const amountOut = yield raydiumSwap.calcAmountOut(poolInfo, amountIn, direction === "AtoB");
    const amountOutParsed = amountOut.amountOut.raw.toNumber() /
        Math.pow(10, amountOut.amountOut.currency.decimals);
    return {
        amountIn,
        amountOut: amountOutParsed,
    };
});
exports.calcAmountOut = calcAmountOut;
