"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertNumber = exports.convertKeypair = exports.convertPubkey = void 0;
const web3_js_1 = require("@solana/web3.js");
const bs58_1 = __importDefault(require("bs58"));
const convertPubkey = (publicKey) => {
    return new web3_js_1.PublicKey(publicKey);
};
exports.convertPubkey = convertPubkey;
const convertKeypair = (privateKeyBS58) => {
    return web3_js_1.Keypair.fromSecretKey(Uint8Array.from(bs58_1.default.decode(privateKeyBS58)));
};
exports.convertKeypair = convertKeypair;
const convertNumber = (number) => {
    if (isNaN(Number(number))) {
        throw new Error("Invalid number");
    }
    return Number(number);
};
exports.convertNumber = convertNumber;
