import { PublicKey } from "@solana/web3.js";

export type TransferSolsBody = {
  fromPrivKeyBs58: string;
  toPubkey: string;
  sols: string;
};

export type CalcAmountOutBody = {
  tokenA: string;
  tokenB: string;
  amountIn: string;
  direction: "AtoB" | "BtoA";
  slippage: string; // 5%
  priceImpact: string | null;
  fee: string | null;
  feePercent: string;
  feeRecipient: PublicKey;
};

export type SwapBody = CalcAmountOutBody & {
  ownerPrivKeyBs58: string;
};
